<?php
// Funzione per ottenere il nome della scatola tramite ID scatola
function get_box_name_by_id( $box_id ) {
	global $wpdb;
	$table_name = $wpdb->prefix . 'jugo_boxes';

	return $wpdb->get_var( $wpdb->prepare( "SELECT name FROM $table_name WHERE id = %d", $box_id ) );
}

// Funzione per ottenere il nome della scatola tramite ID scatola
function get_pickup_address_name_by_id( $pickup_address_id ) {
	global $wpdb;
	$table_name = $wpdb->prefix . 'jugo_pickup_addresses';

	return $wpdb->get_var( $wpdb->prepare( "SELECT name FROM $table_name WHERE id = %d", $pickup_address_id ) );
}

// Funzione per visualizzare il messaggio di associazione ad una scatola tramite Categoria Prodotto
function show_box_category_link_description( $product_id ) {
	global $wpdb;
	$table_name = $wpdb->prefix . 'jugo_general';

	$row = $wpdb->get_row( "SELECT * FROM $table_name WHERE id = 1" );

	if ( $row->products_box_id ) {
		$box_name = get_box_name_by_id( $row->products_box_id );

		return '<div style="margin-left: 162px;position:relative;bottom:12px;">
						<strong>Attualmente:</strong> Scatola "<strong>' . esc_html( $box_name ) . '</strong>" da: <a href="?page=jugo-plugin.php/#general">Impostazioni generali</a><br>
						</div>';
	}

	// Controlla se il prodotto è associato a una categoria
	$product_categories = wp_get_post_terms( $product_id, 'product_cat', array( 'fields' => 'ids' ) );

	foreach ( $product_categories as $category_id ) {
		// Controlla se la categoria è associata a una scatola
		$box_id     = get_term_meta( $category_id, '_box', true );
		$table_name = $wpdb->prefix . 'jugo_boxes';
		if ( $box_id ) {
			$query = "SELECT id,name, CONCAT(name) AS label FROM $table_name WHERE id = " . $box_id;

			$check = $wpdb->get_results( $query, ARRAY_A );

			$category_name      = get_term( $category_id )->name;
			$category_edit_link = get_edit_term_link( $category_id, 'product_cat' );
			$box_name           = get_box_name_by_id( $box_id );
			if ( ! $check ) {
				return '<div style="margin-left: 162px;position:relative;bottom:12px;color:red;">
						La categoria <a href="' . esc_url( $category_edit_link ) . '">' . esc_html( $category_name ) . '</a> non ha una scatola associata<br>
						</div>';
			}
			if ( ! empty( $box_id ) ) {

				return '<div style="margin-left: 162px;position:relative;bottom:12px;">
						<strong>Attualmente:</strong> Scatola "<strong>' . esc_html( $box_name ) . '</strong>" da: <a href="' . esc_url( $category_edit_link ) . '">' . esc_html( $category_name ) . '</a><br>
						</div>';
			}
		}
	}
}

// Funzione per visualizzare il messaggio di associazione ad un indirizzo di ritiro tramite Categoria Prodotto
function show_pickup_address_category_link_description( $product_id ) {
	global $wpdb;

	$table_name = $wpdb->prefix . 'jugo_general';

	$row = $wpdb->get_row( "SELECT * FROM $table_name WHERE id = 1" );

	$test = get_priority_element_id('products_pickup_id', '_pickup_address',$product_id);

	if ( $test['from'] === 'general' ) {
		$pickup_address_name = get_pickup_address_name_by_id( $row->products_pickup_id );

		return '<div style="margin-left: 162px;position:relative;bottom:12px;">
						<strong>Attualmente:</strong> Indirizzo "<strong>' . esc_html( $pickup_address_name ) . '</strong>" da: <a href="?page=jugo-plugin.php/#general">Impostazioni generali</a><br>
						</div>';
	}
	if($test['from'] === 'category') {
		// Controlla se il prodotto è associato a una categoria
		$product_categories = wp_get_post_terms( $product_id, 'product_cat', array( 'fields' => 'ids' ) );

		foreach ( $product_categories as $category_id ) {
			// Controlla se la categoria è associata a un indirizzo
			$pickup_address_id = get_term_meta( $category_id, '_pickup_address', true );
			$table_name        = $wpdb->prefix . 'jugo_pickup_addresses';
			if ( $pickup_address_id ) {
				$query = "SELECT id,name, CONCAT(name) AS label FROM $table_name WHERE id = " . $pickup_address_id;

				$check = $wpdb->get_results( $query, ARRAY_A );


				$category_name       = get_term( $category_id )->name;
				$category_edit_link  = get_edit_term_link( $category_id, 'product_cat' );
				$pickup_address_name = get_pickup_address_name_by_id( $pickup_address_id );
				if ( ! $check ) {
					return '<div style="margin-left: 162px;position:relative;bottom:12px;color:red;">
						La categoria <a href="' . esc_url( $category_edit_link ) . '">' . esc_html( $category_name ) . '</a> non ha un indirizzo associato<br>
						</div>';
				}
				if ( ! empty( $pickup_address_id ) ) {
					return '<div style="margin-left: 162px;position:relative;bottom:12px;">
						<strong>Attualmente:</strong> Indirizzo "<strong>' . esc_html( $pickup_address_name ) . '</strong>" da: <a href="' . esc_url( $category_edit_link ) . '">' . esc_html( $category_name ) . '</a><br>
						</div>';
				}
			}
		}
	}
}

// Funzione per ottenere l'ID di un elemento con priorità (box, indirizzi di ritiro)
function get_priority_element_id( $what, $slug, $product_id ) {
	global $wpdb;

	$table_name = $wpdb->prefix . 'jugo_general';

	$row = $wpdb->get_row( "SELECT * FROM $table_name WHERE id = 1" );

	$element_id = null;
	$from = null;

	// 1. Da TAB "Impostazioni generali"
	if ($row->$what ) {
		$element_id = $row->$what;
		$from = 'general';
	} else {
		// 2. Da Categoria Prodotto
		$product_element_id = get_post_meta( $product_id, $slug, true );
		$category_ids = wp_get_post_terms( $product_id, 'product_cat', array( 'fields' => 'ids' ) );

		foreach ( $category_ids as $category_id ) {
			$category_element_id = get_term_meta( $category_id, $slug, true );
			if ( $category_element_id && ! $product_element_id ) {
				$element_id = $category_element_id;
				$from = 'category';
			}
		}
		// 3. Da Prodotto
		if ( $product_element_id != null) {
			$element_id = $product_element_id;
			$from = 'product';
		}
	}


	return [
		'id' => $element_id,
		'from' => $from
	];
}

// Funzione per ottenere i Servizi Opzionali selezionati dall'admin
function get_optional_services_options() {
	global $wpdb;
	$order_total = WC()->cart->total;
	$table_name  = $wpdb->prefix . 'jugo_optional_services';

	// Recupera le opzioni dei servizi opzionali dalla tabella jugo_optional_services
	$optional_services = $wpdb->get_row( "SELECT * FROM $table_name" );

	// Verifica se i servizi opzionali sono abilitati
	$ensurance_enabled = ! ! $optional_services->ensurance;
	$priority_enabled  = ! ! $optional_services->priority;
	$mark_enabled      = ! ! $optional_services->mark;
	$mark_value        = $optional_services->mark_value;

	// Costruisci l'array delle opzioni in base ai servizi abilitati
	$options = array();

	if ( $ensurance_enabled ) {
		$options['ensurance'] = __( 'Assicurazione' );
	}

	if ( $priority_enabled ) {
		$options['priority'] = __( 'Priority' );
	}

	if ( $mark_enabled && $order_total >= $mark_value ) {
		$options['mark'] = __( 'Pagamento alla Consegna' );
	}

	return $options;
}

// Funzione per ottenere il valore del contrassegno
function get_mark_value() {
	global $wpdb;
	$table_name = $wpdb->prefix . 'jugo_optional_services';

	// Recupera il valore mark_value dalla tabella jugo_optional_services
	$mark_value = $wpdb->get_var( "SELECT mark_value FROM $table_name" );

	return $mark_value;
}

// Funzione per ottenere il contrassegno
function is_mark_enabled() {
	global $wpdb;
	$table_name = $wpdb->prefix . 'jugo_optional_services';

	// Recupera lo stato di mark dalla tabella jugo_optional_services
	$mark_enabled = $wpdb->get_var( "SELECT mark FROM $table_name" );

	return $mark_enabled;
}

// Funzione che effettua una chiamata agli endpoint JUGO per ricevere il prezzo per il servizio "Priority"
function get_priority_service_price() {
	// Ottieni l'API Key dal database o dalle impostazioni
	$api_key = get_option( 'jugo_settings_api_key' ); // Sostituisci con il tuo valore reale

	// Effettua una chiamata all'endpoint esterno di JUGO per ottenere il prezzo del servizio "Priority"
	$api_url  = 'https://api.example.com/get-priority-price'; // Sostituisci con il tuo URL reale
	$response = wp_safe_remote_get( $api_url, array(
		'headers' => array(
			'Authorization' => 'Bearer ' . $api_key,
		),
	) );

	if ( is_wp_error( $response ) ) {
		return 0; // Gestisci l'errore in base alle tue esigenze
	}

	$body = wp_remote_retrieve_body( $response );
	$data = json_decode( $body, true );

	if ( isset( $data['price'] ) ) {
		return floatval( $data['price'] );
	} else {
		return 0; // Gestisci la mancanza del prezzo in base alle tue esigenze
	}
}

// Fetch Utente JUGO
add_action( 'wp_ajax_nopriv_fetch_jugo_user', 'fetch_jugo_user' );
add_action( 'wp_ajax_fetch_jugo_user', 'fetch_jugo_user' );
function fetch_jugo_user() {
	global $wpdb;
	$response = wp_remote_get( JUGO_BASE_URL . "/api/v2/user", [
		'headers' => [
			'Authorization' => 'Bearer ' . get_option( 'jugo_settings_api_key' ),
			'Accept'        => 'json-application'
		]
	] );

	$user = json_decode( $response['body'], true );

	// Recupero IBAN dalla tabella jugo_optional_services
	$table_name = $wpdb->prefix . 'jugo_optional_services';

	// Recupera le opzioni dei servizi opzionali dalla tabella jugo_optional_services
	$iban = $wpdb->get_row( "SELECT iban FROM $table_name" );

	$user['iban'] = $iban->iban ?? null;

	wp_send_json( $user );
	wp_die();
}

// Verifica se Woocommerce ha IVA incl. o escl.
add_action( 'wp_ajax_get_wc_tax', 'get_wc_tax' );
add_action( 'wp_ajax_nopriv_get_wc_tax', 'get_wc_tax' );
function get_wc_tax() {
	if ( wc_prices_include_tax() ) {
		wp_send_json(true);
	} else {
		wp_send_json(false);
	}
}

// Verifica dei dati per procedere al calcolo delle spese di spedizione
add_action( 'wp_ajax_verify_data_and_calculate_shipping', 'verify_data_and_calculate_shipping' );
add_action( 'wp_ajax_nopriv_verify_data_and_calculate_shipping', 'verify_data_and_calculate_shipping' );
function verify_data_and_calculate_shipping() {
	$errors = [];

	// Verifica i campi
	$billing_country = sanitize_text_field( $_POST['billing_country'] );
	$billing_region  = sanitize_text_field( $_POST['billing_region'] );

	if ( empty( $billing_country ) || $billing_country === 'null' ) {
		$errors[] = 'Il campo Nazione è obbligatorio.';
	}
	if ( $billing_country === '15' ) {
		if ( empty( $billing_region ) ) {
			$errors[] = 'Il campo Regione è obbligatorio.';
		}
	}

	wp_send_json( [ 'errors' => $errors ] );
	wp_die();
}

// Verifica dati indirizzo in fase di checkout
add_action( 'wp_ajax_verify_address_data', 'verify_address_data' );
add_action( 'wp_ajax_nopriv_verify_address_data', 'verify_address_data' );
function verify_address_data() {
	$errors = [];

	// Verifica i campi
	$billing_first_name = sanitize_text_field( $_POST['billing_first_name'] );
	$billing_last_name  = sanitize_text_field( $_POST['billing_last_name'] );
	$billing_country    = sanitize_text_field( $_POST['billing_country'] );
	$billing_region     = sanitize_text_field( $_POST['billing_region'] );
	$billing_state      = sanitize_text_field( $_POST['billing_state'] );
	$billing_city       = sanitize_text_field( $_POST['billing_city'] );
	$billing_postcode   = sanitize_text_field( $_POST['billing_postcode'] );
	$billing_address_1  = sanitize_text_field( $_POST['billing_address_1'] );
	$billing_phone      = sanitize_text_field( $_POST['billing_phone'] );
	$billing_email      = sanitize_text_field( $_POST['billing_email'] );

	if ( empty( $billing_first_name ) || empty( $billing_last_name ) || empty( $billing_country ) || empty( $billing_region ) || empty( $billing_state ) || empty( $billing_city ) || empty( $billing_postcode ) || empty( $billing_address_1 ) || empty( $billing_phone ) || empty( $billing_email ) ) {
		$errors[] = 'Compila tutti i campi obbligatori.';
	}

	wp_send_json( [ 'errors' => $errors ] );
	wp_die();
}

// Costruzione oggetto contenente dati necessari per calcolo spese di spedizione
add_action( 'wp_ajax_nopriv_calculate_shipping_cost', 'calculate_shipping_cost' );
add_action( 'wp_ajax_calculate_shipping_cost', 'calculate_shipping_cost' );
function calculate_shipping_cost() {
	global $woocommerce;
	global $wpdb;
	$items            = $woocommerce->cart->get_cart();
	$pickup_addresses = [];
	foreach ( $items as $item => $values ) {
		// Dati Prodotto
		$_product                                                                                    = wc_get_product( $values['data']->get_id() );
		$pickup_address                                                                              = get_priority_element_id('products_pickup_id', '_pickup_address', $_product->get_id() )['id'];
		$pickup_addresses[ $pickup_address ]['products'][ $_product->get_id() ]['quantity']          = $values['quantity']; // Quantità totale prodotto nel carrello
		$pickup_addresses[ $pickup_address ]['products'][ $_product->get_id() ]['title']             = $_product->get_title(); // Titolo prodotto
		$pickup_addresses[ $pickup_address ]['products'][ $_product->get_id() ]['weight']            = get_post_meta( $_product->get_id(), '_product_weight', true ); // Peso prodotto
		$pickup_addresses[ $pickup_address ]['products'][ $_product->get_id() ]['box']['id']         = get_priority_element_id('products_box_id', '_box',  $_product->get_id() )['id']; // Scatola associata a prodotto
		$pickup_addresses[ $pickup_address ]['products'][ $_product->get_id() ]['box']['percentage'] = get_post_meta( $_product->get_id(), '_box_percentage', true ); // Percentuale occupazione prodotto nella scatola
		// Dati Scatola
		$box_table = $wpdb->prefix . 'jugo_boxes';
		$box_id    = get_priority_element_id('products_box_id', '_box', $_product->get_id() )['id'];
		$query     = $wpdb->prepare( "SELECT * FROM $box_table WHERE id = %d", $box_id );
		$_box      = $wpdb->get_row( $query, ARRAY_A );
		// Lati Scatola
		$pickup_addresses[ $pickup_address ]['products'][ $_product->get_id() ]['box']['lato_1'] = $_box['lato_1'];
		$pickup_addresses[ $pickup_address ]['products'][ $_product->get_id() ]['box']['lato_2'] = $_box['lato_2'];
		$pickup_addresses[ $pickup_address ]['products'][ $_product->get_id() ]['box']['lato_3'] = $_box['lato_3'];
		// Dati Indirizzo di ritiro
		$pickup_address_table                              = $wpdb->prefix . 'jugo_pickup_addresses';
		$pickup_address_id                                 = get_priority_element_id('products_pickup_id', '_pickup_address', $_product->get_id() )['id'];
		$query                                             = $wpdb->prepare( "SELECT * FROM $pickup_address_table WHERE id = %d", $pickup_address_id );
		$_pickup_address                                   = $wpdb->get_row( $query, ARRAY_A );
		$pickup_addresses[ $pickup_address ]['sender_id']  = $_pickup_address['jugo_id'];
		$pickup_addresses[ $pickup_address ]['country_id'] = $_pickup_address['country_id'];
		$pickup_addresses[ $pickup_address ]['region_id']  = $_pickup_address['region_id'];
	}

	// Raggruppo i prodotti per la stessa scatola associata.
	foreach ( $pickup_addresses as $pickup_address_id => $pickup_address ) {
		if ( gettype( $pickup_address ) === 'array' ) {
			foreach ( $pickup_address['products'] as $id => $product ) {
				$box_id     = $product['box']['id'];
				$percentage = $product['box']['percentage'] * $product['quantity'];
				$weight     = $product['weight'] * $product['quantity'];


				if ( ! isset( $pickup_addresses[ $pickup_address_id ]['boxes'][ $box_id ] ) ) {
					$pickup_addresses[ $pickup_address_id ]['boxes'][ $box_id ] = [
						'total_box'         => 0, // Numero di colli
						'total_weight'      => 0, // Totale peso collo in kg
						'length'            => $product['box']['lato_1'], // Lunghezza
						'width'             => $product['box']['lato_2'], // Larghezza
						'height'            => $product['box']['lato_3'], // Altezza
						'total_percentage'  => 0, // Totale % di occupazione
						'sender_country_id' => '15', // Nazione mittente (Italia)
						'sender_region_id'  => $pickup_addresses[ $pickup_address_id ]['region_id']
					];
				}
				$pickup_addresses[ $pickup_address_id ]['boxes'][ $box_id ]['total_weight']     += $weight;
				$pickup_addresses[ $pickup_address_id ]['boxes'][ $box_id ]['total_percentage'] += $percentage;
				$pickup_addresses[ $pickup_address_id ]['boxes'][ $box_id ]['total_box']        = ceil( $pickup_addresses[ $pickup_address_id ]['boxes'][ $box_id ]['total_percentage'] / 100 );
			}
		}
	}

	echo json_encode( [
		'pickup_addresses' => $pickup_addresses,
		'cart_subtotal'    => $woocommerce->cart->get_subtotal()
	] );
	wp_die();
}

// Fetch visualizzazione tariffe
add_action( 'wp_ajax_nopriv_rates_view', 'rates_view' );
add_action( 'wp_ajax_rates_view', 'rates_view' );
function rates_view() {
	global $wpdb;
	$table_name = $wpdb->prefix . 'jugo_rates_view';
	$rates_view = $wpdb->get_row( "SELECT rate_type, unique_type FROM $table_name" );

	echo json_encode( $rates_view );
	wp_die();
}

// Fetch visualizzazione servizi opzionali
add_action( 'wp_ajax_nopriv_optional_services_view', 'optional_services_view' );
add_action( 'wp_ajax_optional_services_view', 'optional_services_view' );
function optional_services_view() {
	global $wpdb;
	$table_name = $wpdb->prefix . 'jugo_optional_services';

	// Recupera le opzioni dei servizi opzionali dalla tabella jugo_optional_services
	$optional_services = $wpdb->get_row( "SELECT * FROM $table_name" );

	// Verifica se i servizi opzionali sono abilitati
	$ensurance_enabled = ! ! $optional_services->ensurance;
	$priority_enabled  = ! ! $optional_services->priority;
	$mark_enabled      = ! ! $optional_services->mark;
	$mark_value        = $optional_services->mark_value;
	$iban              = $optional_services->iban;

	$optional_services = [
		'ensurance'  => $ensurance_enabled,
		'priority'   => $priority_enabled,
		'mark'       => $mark_enabled,
		'mark_value' => $mark_value,
		'iban'       => $iban
	];

	echo json_encode( $optional_services );
	wp_die();
}

// Fetch visualizzazione servizi opzionali
add_action( 'wp_ajax_nopriv_general', 'general' );
add_action( 'wp_ajax_general', 'general' );
function general() {
	global $wpdb;
	$table_name = $wpdb->prefix . 'jugo_general';

	// Recupera le opzioni dei servizi opzionali dalla tabella jugo_optional_services
	$general = $wpdb->get_row( "SELECT * FROM $table_name" );

	$general->wc_include_tax = wc_prices_include_tax();

	echo json_encode( $general );
	wp_die();
}